﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace MultOptionDataFilter.Controls
{
    public class FilterOptionSelecteable : ViewModelBase
    {
        public FilterOptionSelecteable(object value)
        {
            Value = value;
            DisplayValue = value;
        }
        public FilterOptionSelecteable(object value, bool isChecked)
            : this(value)
        {
            _isChecked = isChecked;
        }
        public FilterOptionSelecteable(object value, bool isChecked, object displayValue)
            : this(value, isChecked)
        {
            DisplayValue = displayValue;
        }
        public event EventHandler<FilterOptionCheckedChangedEventArgs> IsCheckedChanged;
        private bool _isChecked;

        public bool IsChecked
        {
            get { return _isChecked; }
            set
            {
                if (_isChecked != value)
                {
                    _isChecked = value;
                    OnPropertyChanged("IsChecked");
                    OnIsCheckedChanged();
                }
            }
        }


        public object Value { get; set; }
        public object DisplayValue { get; set; }
        protected virtual void OnIsCheckedChanged()
        {
            if (IsCheckedChanged != null)
                IsCheckedChanged(this, new FilterOptionCheckedChangedEventArgs(IsChecked, Value));
        }

    }

    public class FilterOptionCheckedChangedEventArgs : EventArgs
    {
        public bool IsChecked { get; private set; }
        public object Value { get; private set; }
        public FilterOptionCheckedChangedEventArgs(bool isChecked, object value)
        {
            IsChecked = isChecked;
            Value = value;
        }

    }
}
