﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Data.DataFilter;
using Telerik.Windows.Data;

namespace MultOptionDataFilter.Controls
{
    public class FilterTemplateSelector : DataTemplateSelector
    {
        public DataTemplate MultiOptionEditorTemplate { get; set; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var info = item as ItemPropertyDefinition;
            if (info != null)
            {
                var filterEditor = container as FilterEditor;
                if ((filterEditor.FilterOperator == FilterOperator.IsEqualTo || filterEditor.FilterOperator == FilterOperator.IsNotEqualTo) && info.PropertyType != typeof(DateTime) && info.PropertyType != typeof(TimeSpan))
                    return MultiOptionEditorTemplate;
            }
            return base.SelectTemplate(item, container);
        }
    }
}
