﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace MultOptionDataFilter.ViewModel
{
    public static class PredicateExtensions
    {
        public static Predicate<T> And<T>(this Predicate<T> first, Predicate<T> second)
        {
            if (first == null)
                return second;
            if (second == null)
                return first;
            return c => first(c) && second(c);
        }
        
        public static Predicate<T> Or<T>(this Predicate<T> first, Predicate<T> second)
        {
            if (first == null)
                return second;
            if (second == null)
                return first;
            return c => first(c) || second(c);
        }
    }
}
